• HDU 1024 Max Sum Plus Plus (DP+滚动数组优化)


    题目

    Problem Description
    Now I think you have got an AC in Ignatius.L's "Max Sum" problem. To be a brave ACMer, we always challenge ourselves to more difficult problems. Now you are faced with a more difficult problem.

    Given a consecutive number sequence S1, S2, S3, S4 ... Sx, ... Sn (1 ≤ x ≤ n ≤ 1,000,000, -32768 ≤ Sx ≤ 32767). We define a function sum(i, j) = Si + ... + Sj (1 ≤ i ≤ j ≤ n).

    Now given an integer m (m > 0), your task is to find m pairs of i and j which make sum(i1, j1) + sum(i2, j2) + sum(i3, j3) + ... + sum(im, jm) maximal (ix ≤ iy ≤ jx or ix ≤ jy ≤ jx is not allowed).

    But I`m lazy, I don't want to write a special-judge module, so you don't have to output m pairs of i and j, just output the maximal summation of sum(ix, jx)(1 ≤ x ≤ m) instead. _

    Input
    Each test case will begin with two integers m and n, followed by n integers S1, S2, S3 ... Sn.
    Process to the end of file.

    Output
    Output the maximal summation described above in one line.

    Sample Input
    1 3 1 2 3
    2 6 -1 4 -2 3 -2 3

    Sample Output
    6
    8

    思路

    这个逼题目好题目,首先状态方程很好写:(dp[i][j]=max (dp[i-1][j],dp[t][j-1])+a[i]),但是你抬头看一下1e6的数组,直接宣判封顶,而且你这个空间上估计也会炸裂。当然第一步的话肯定先把数组滚起来,然后我们可以发现取j-1个组的时候转移过来的时候肯定是取最大的,所以我们在每次dp完事后,维护一个max数组用于下一层的计算。

    代码实现

    #include<bits/stdc++.h>
    using namespace std;
    typedef long long ll;
    const int maxn=1e6+10;
    const int inf=0x3f3f3f3f;
    void check_min (int &a,int b) {a=min (a,b);}
    void check_max (int &a,int b) {a=max (a,b);}
    int n,m;
    int a[maxn],last_max [maxn];
    int dp[maxn];
    
    int main () {
        while (~scanf ("%d%d",&m,&n)) {
            for (int i=1;i<=n;i++) scanf ("%d",&a[i]);
            memset (dp,0,sizeof (dp));
            memset (last_max,0,sizeof (last_max));
            int temp;
            for (int i=1;i<=m;i++) {
                temp=-1e9;
                for (int j=i;j<=n;j++) {
                    dp[j]=max (dp[j-1],last_max[j-1])+a[j];
                    last_max[j-1]=temp;
                    check_max (temp,dp[j]);
                } 
            }
            printf ("%d
    ",temp);
        }
    
        return 0;
    }
    
  • 相关阅读:
    对图像边缘进行随机均匀采样的C#算法实现
    [淡藤]最近几年在Chinapub上买的书
    重新认识C#: 玩转指针
    又是一年春来到
    需求定律在起着作用
    haha, 愚人节听鱼人歌
    名字就叫奥格工作室!
    effective c++ 第六章
    com 名字对象(1)IBindCtx
    com 名字对象(2)创建名字对象(IMoniker)
  • 原文地址:https://www.cnblogs.com/hhlya/p/13907504.html
Copyright © 2020-2023  润新知